﻿using Infragistics.Win.DataVisualization;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraDataChartCategoryTooltip
{
    public partial class Form1 : Form
    {

        Label newChartLabel = new Label();
        public Form1()
        {
            //new Infragistics.Win.UIElementViewer.UIElementViewerDialog().Show();
            InitializeComponent();
           
            ObservableCollection<SampleData> data = new ObservableCollection<SampleData>();

            for(int i=1; i<5; i++)
            {
                data.Add(new SampleData()
                {
                    Label = "Lbl " + i.ToString(),
                    SampleValue1 = i,
                    SampleValue2 = i*2,
                    SampleValue3 = i*3
                });
            }

            CategoryXAxis xAxis = new CategoryXAxis() { DataSource = data, Label = "Label" };
            NumericYAxis yAxis = new NumericYAxis() { MinimumValue = 0, MaximumValue = 15 };

            ultraDataChart1.Axes.Add(xAxis);
            ultraDataChart1.Axes.Add(yAxis);           

            ultraDataChart1.Series.Add(CreateColumnSeries(xAxis, yAxis, data, "SampleValue1"));
            ultraDataChart1.Series.Add(CreateColumnSeries(xAxis, yAxis, data, "SampleValue2"));
            ultraDataChart1.Series.Add(CreateColumnSeries(xAxis, yAxis, data, "SampleValue3"));
        
            CategoryToolTipLayer layer = new CategoryToolTipLayer() { Brush = Brushes.Black, Outline = Brushes.Red, };

                     
            ultraDataChart1.Series.Add(layer);
        }


        public ColumnSeries CreateColumnSeries(CategoryXAxis xAxis, NumericYAxis yAxis, IEnumerable dataSource, string valueMemberPath)
        {
            ColumnSeries series = new ColumnSeries() { XAxis = xAxis, YAxis = yAxis, DataSource = dataSource, ValueMemberPath = valueMemberPath, ShowDefaultTooltip = true };
            series.TooltipContentUpdating += Series_TooltipContentUpdating;
            return series;
        }

        private Control Series_TooltipContentUpdating(object sender, ChartTooltipContentEventArgs e)
        {
            var item = e.DataContext.Item as SampleData;

            newChartLabel.Text = "Replaced Label 1 = " + item.SampleValue1
                + Environment.NewLine + "Replaced Label 2 = " + item.SampleValue2
                + Environment.NewLine + "Replaced Label 3 = " + item.SampleValue3;
            newChartLabel.ForeColor = Color.Yellow;
            newChartLabel.BackColor = Color.DarkBlue;
            newChartLabel.AutoSize = true;
            return newChartLabel;      
        }
    }

    public class SampleData
    {
        public string Label { get; set; }
        public int SampleValue1 { get; set; }
        public int SampleValue2 { get; set; }
        public int SampleValue3 { get; set; }
    }
}
